package org.example.models.trading;

import org.apache.commons.math3.random.RandomGenerator;
import simudyne.core.abm.GlobalState;
import simudyne.core.annotations.Input;
import simudyne.core.rng.SeededRandom;

import java.util.Random;

public class Globals extends GlobalState {

    @Input(name = "Number of Noise Traders")
    public long nbNoiseTraders = 10;

    @Input(name = "Number of Momentum Traders")
    public long nbMomentumTraders = 10;

    @Input(name = "Number of Fundamental Traders")
    public long nbFundamentalTraders = 10;

    @Input(name = "Kyle's lambda")
    public double lambda = 1;

    @Input(name = "priceDistortion")
    public double priceDistortion = .1;

    @Input(name = "v0")
    public double v0 = 5;

    @Input(name = "m0")
    public double m0 = 0;

    @Input(name = "g")
    public double mu_v = 0;

    @Input(name = "sigma_v")
    public double sigma_v = 0;

    @Input(name = "kappa")
    public double kappa = 0;

    @Input(name = "kappa_3")
    public double kappa_3 = 0;

    @Input(name = "alpha")
    public double alpha = .175;

    @Input(name = "gamma")
    public double gamma = 50;

    @Input(name = "beta")
    public double beta = 0;

    @Input(name = "sigma_n")
    public double sigma_n =  1;

    public double v;

    private SeededRandom rng;


    public Globals() {v = v0;
    }


    public void init(long seed) {rng = SeededRandom.create(seed);
    }


    public void step() {v += (rng.normal(0,1).sample() * sigma_v) + mu_v;
    }
}
