package org.example.models.trading;

public class NoiseTrader extends BaseTrader {

    public double sigma_n;

    public double probability_order;


    @Override
    public void handleMarketInformation(Messages.MarketChange msg) {
        // Do nothing as the noise trader needs no market information to inform its decisions.
    }


    @Override
    public Side getSide() {
        if (getPrng().uniform(0, 1).sample() < probability_order)
            return getPrng().uniform(0, 1).sample() < 0.5 ? Side.BUY : Side.SELL;
        else
            return Side.WAIT;
    }


    @Override
    public double getDemand() {return sigma_n;
    }
}